moGreenhouses = {};
source(MultiOverlayV3.modDir.."scripte/module/greenhouses/moGreenhousesConfig.lua");

function moGreenhouses:update(dt)
	if moModule.active.greenhouses.isRunning then
		if moGreenhouses.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateGreenhouses"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moGreenhouses.values.updateTimer, name="updateGreenhouses", repeatable=1, ms=false, action=moGreenhouses.load} ); 
		else
			moGreenhouses:load();
		end;
	end;
end;

function moGreenhouses:load()
	moGreenhouses:loadGreenhouses();	
end;

local test = true;
function moGreenhouses:loadGreenhouses()
	local playerFarmId = g_currentMission.player.farmId;	
	moGreenhouses.values.greenhouses = {}; --new 
	if moModule.greenhouses ~= nil and #moModule.greenhouses > 0 then
		local deleteObject = {};
		for index=1, #moModule.greenhouses do			
			if moModule.greenhouses[index] ~= nil then
				local isObject = moModule:isObject(moModule.greenhouses[index].object);
				if isObject then
					local greenhouse = moModule.greenhouses[index].object;
					if greenhouse.ownerFarmId == 0 or greenhouse.ownerFarmId == playerFarmId then
						local greenhouseName = moModule.greenhouses[index].xmlName;
						if moGreenhouses.values.greenhouses[greenhouseName] == nil then moGreenhouses.values.greenhouses[greenhouseName] = {};end;
						moGreenhouses.values.greenhouses[greenhouseName][#moGreenhouses.values.greenhouses[greenhouseName]+1] = {general={},output={},input={}};
						---
						local lineTableGeneral = moGreenhouses.values.greenhouses[greenhouseName][#moGreenhouses.values.greenhouses[greenhouseName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = greenhouse;
						isLineTableGeneral.ownerFarmId = greenhouse.ownerFarmId or 0;
						isLineTableGeneral.objectName = moModule.greenhouses[index].name;
						if moModule.greenhouses[index].mohDisplayName ~= nil then isLineTableGeneral.objectName = moModule.greenhouses[index].mohDisplayName;end;
						isLineTableGeneral.xmlName = greenhouseName;
						--isLineTableGeneral.greenhouseCmd = "greenhouses_".. greenhouseName;						
						isLineTableGeneral.productivity = 0; 
						isLineTableGeneral.productivityName = moLanguageXml:getTxt("productivity", nil, g_i18n:getText("statistic_productivity"));
						isLineTableGeneral.productivityColor = 1;
						---
						local lineTableOutput = moGreenhouses.values.greenhouses[greenhouseName][#moGreenhouses.values.greenhouses[greenhouseName]].output;
						lineTableOutput[#lineTableOutput+1] = {};						
						local isLineTableOutput = lineTableOutput[#lineTableOutput];
						isLineTableOutput.age = greenhouse.age;
						isLineTableOutput.incomePerHour = greenhouse.incomePerHour;						
						---
						local lineTableInput = moGreenhouses.values.greenhouses[greenhouseName][#moGreenhouses.values.greenhouses[greenhouseName]].input;						
						local fillLevel = 0;
						local capacity = 0;
						if greenhouse.waterTankStation ~= nil then
							local indexWater = g_currentMission.fillTypeManager.nameToIndex["WATER"];
							if indexWater ~= nil and indexWater ~= 0 then
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];							
								isLineTableInput.fillTypeName = moFillTypes.values.fillTypes[indexWater].name;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(greenhouse.waterTankFillLevel, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(greenhouse.waterTankCapacity, 0));
								fillLevel = fillLevel+Utils.getNoNil(greenhouse.waterTankFillLevel, 0);capacity = capacity+Utils.getNoNil(greenhouse.waterTankCapacity, 0);
								local waterPer = math.floor((Utils.getNoNil(greenhouse.waterTankFillLevel, 0) / Utils.getNoNil(greenhouse.waterTankCapacity, 0)) * 100);
								isLineTableInput.percentageCapacity = waterPer;
							end;							
						end;						
						if greenhouse.manureTankStation ~= nil then
							local indexManure = g_currentMission.fillTypeManager.nameToIndex["MANURE"];
							if indexManure ~= nil and indexManure ~= 0 then
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];							
								isLineTableInput.fillTypeName = moFillTypes.values.fillTypes[indexManure].name;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(greenhouse.manureTankFillLevel, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(greenhouse.manureTankCapacity, 0));
								fillLevel = fillLevel+Utils.getNoNil(greenhouse.manureTankFillLevel, 0);capacity = capacity+Utils.getNoNil(greenhouse.manureTankCapacity, 0);
								local manurePer = math.floor((Utils.getNoNil(greenhouse.manureTankFillLevel, 0) / Utils.getNoNil(greenhouse.manureTankCapacity, 0)) * 100);
								isLineTableInput.percentageCapacity = manurePer;
							end;
						end;
						isLineTableGeneral.productivity = g_i18n:formatNumber(Utils.getNoNil(fillLevel/capacity, 0)*100);
						isLineTableGeneral.productivityColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(fillLevel/capacity, 0)*100, true}, "getProzentColor Productivity ".. tostring(greenhouseName));						
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.greenhouses, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;
end;




